{ Move2SF - An OLE plugin for JED versions 8 and higher.
  This moves the current thing to the center of the current surface.
  Written by Craig Urquhart (Ugg_Boot) 30Nov98. Email: cu@rpi.net.au
  Imperial Detention Center: http://www.rpi.net.au/~cu/main.html }

program Move2SF;

{You need 'ComObj' for the OLE connection, and 'Windows' for the message box.
 If you used the Delphi ShowMessage box you would need 'Dialogs' which would
 add another 100K to your executable for almost no advantage}
uses
    SysUtils, ComObj, Windows;

var
   Jed: variant;

procedure StartUp;
begin
{Try to connect to Jed through OLE. Check that Jed is running and check that
 it's version supports OLE}
     try
        Jed := CreateOleObject('JED.App');
     except
           MessageBox(0, PChar('START JED (v8+) BEFORE USE.'),
                     PChar('BringBring'), MB_ICONEXCLAMATION);
           Halt(1);
     end;
     if Jed.Version < 0.8 then
     begin
          MessageBox(0, PChar('REQUIRES JED VERSION 8 OR HIGHER.'),
                     PChar('BringBring'), MB_ICONEXCLAMATION);
          Halt(1);
     end;
end;

procedure MoveToCenter;
var
   SCO, SFO, THO: variant;
   SC, SF, VX, TH, n: integer;
   X, Y, Z, XSUM, YSUM, ZSUM: double;
begin
{setup a variant for each object we will use }
     Jed.GetCurSF(SC, SF);
     TH := Jed.CurTH;
     SCO := Jed.Level.GetSector(SC);
     SFO := Jed.Level.GetSurface(SC, SF);
     THO := Jed.Level.GetThing(TH);
{make sure these really are zero when you initalise them, otherwise the center
 will be in the wrong place}
     XSUM := 0;
     YSUM := 0;
     ZSUM := 0;
{add up the X, Y, Z values for each vertex on the surface and the averages will
 be the approximate center of the surface}
     for n := 0 to (SFO.NVertices - 1) do
     begin
          VX := SFO.GetVertex(n);
          SCO.GetVertex(VX, X, Y, Z);
          XSUM := XSUM + X;
          YSUM := YSUM + Y;
          ZSUM := ZSUM + Z;
     end;
     X := XSUM / SFO.NVertices;
     Y := YSUM / SFO.NVertices;
     Z := ZSUM / SFO.NVertices;
{move the thing to this center and update the thing, and update Jed display}
     THO.SetXYZ(X, Y, Z);
     THO.Sector := SC;
     THO.Update;
     Jed.UpdateMap;
end;

{this is the 'main' program which is run first}
begin
     StartUp;                {try to connect to JED through OLE, otherwise quit}
     MoveToCenter;           {pretty damm obvious!}
end.









