{ Rotate2SF - An OLE plugin for JED versions 8 and higher.
  This aligns the current thing with the normal of the current surface.
  Written by Craig Urquhart (Ugg_Boot) 29Nov98. Email: cu@rpi.net.au
  Imperial Detention Center: http://www.rpi.net.au/~cu/main.html }

program Rotate2SF;

{You need 'ComObj' for the OLE connection, and 'Windows' for the message box.
 If you used the Delphi ShowMessage box you would need 'Dialogs' which would
 add another 100K to your executable for almost no advantage}
uses
    SysUtils, ComObj, Windows;

var
   Jed: variant;

const
     PI = 3.141592654;

procedure StartUp;
begin
{Try to connect to Jed through OLE. Check that Jed is running and check that
 it's version supports the OLE functions used}
     try
        Jed := CreateOleObject('JED.App');
     except
           MessageBox(0, PChar('START JED (v8+) BEFORE USE.'),
                     PChar('BringBring'), MB_ICONEXCLAMATION);
           Halt(1);
     end;
     if Jed.Version < 0.8 then
     begin
          MessageBox(0, PChar('REQUIRES JED VERSION 8 OR HIGHER.'),
                     PChar('BringBring'), MB_ICONEXCLAMATION);
          Halt(1);
     end;
end;

{Only reason this function is in here is because Delphi 3 Standard gives you
 ArcTan, but not ArcSin or ArcCos, they are included in the 'Math' unit which
 ships with the Professional version...bastards!}
function ArcCos(x: extended): extended;
begin
     if x = 1 then
        ArcCos := 0
     else if x = -1 then
        ArcCos := PI
     else
         ArcCos := (PI / 2) - ArcTan(x / Sqrt(1 - Sqr(x)));
end;

procedure Rotate;
var
   SFO, THO: variant;
   SC, SF, TH: integer;
   NX, NY, NZ, PITCH, YAW, ROLL: double;
begin
{Setup a variant for the current surface and read it's normal vector}
     Jed.GetCurSF(SC, SF);
     SFO := Jed.Level.GetSurface(SC, SF);
     SFO.GetNormal(NX, NY, NZ);
{Calculate the pitch and yaw of the surface normal. Roll is not calculated
 since that is just a rotation about the normal}
     PITCH := 90 - (ArcCos(NZ) * (180 / PI));
     YAW := ArcCos(NY) * (180 / PI);
     if NX > 0 then YAW := 360 - YAW;
{Apply these angles to the current thing}
     TH := Jed.CurTH;
     THO := Jed.Level.GetThing(TH);
     ROLL := THO.ROL;
     THO.SetOrient(PITCH, YAW, ROLL);
     THO.Update;
     Jed.UpdateMap;
end;

{This is the 'main' program which is run first}
begin
     StartUp;                {Try to connect to JED through OLE, otherwise quit}
     Rotate;                 {Pretty damm obvious!}
end.
