program jktree;
{This is an example of a simple JED Plugin
 What is does is converts old style JED project
 directory to "new style" one - containing the
 JK directory tree}

uses OLEAuto,Windows,SysUtils;
var jed:variant;
    fname,pdir:string;
    sr:TSearchRec;
    res:integer;

Procedure Stop(const msg,hdr:string);
begin
 MessageBox(0,Pchar(msg),pchar(hdr),mb_OK);
 halt;
end;

Procedure ForceDirectories(const dir,subdir:string);
{Creates entire subdir path if it doesn't exist
 For instance if subdir=3do\key\ it will create
 subdirectory 3do and subdirectory key in it}
var cdir:string;
    cpos,spos:integer;
begin

 cpos:=1; cdir:='';

 repeat
  spos:=cpos;

  while cpos<=length(subdir) do
   if subdir[cpos]<>'\' then inc(cpos) else break;

  if cpos=spos then break;
  cdir:=Copy(subdir,1,cpos-1);

  {$i-}
  MkDir(dir+cdir);
  if ioresult<>0 then;

  inc(cpos);

 until false;

end;



Procedure MoveFile(const name:string);
{Moves a file from directory "pdir" (Project directory)
 to the appropriate subdirectory - defined by file's
 extension} 
var ext:string;
    newpath:string;
begin
 ext:=UpperCase(ExtractFileExt(name));
 newpath:='';

 if ext='.JKL' then newpath:='jkl\'
 else if ext='.COG' then newpath:='cog\'
 else if ext='.3DO' then newpath:='3do\'
 else if ext='.MAT' then newpath:='mat\'
 else if ext='.DAT' then newpath:='misc\'
 else if ext='.UNI' then
 begin
  if (CompareText(name,'cogstrings.uni')=0) or (CompareText(name,'sithstrings.uni')=0)
    then newpath:='misc\' else newpath:='ui\';
 end
 else if ext='.KEY' then newpath:='3do\key\'
 else if (ext='.AI') or (ext='.AI0') or (ext='.AI2') then newpath:='misc\ai\'
 else if ext='.CMP' then newpath:='misc\cmp\'
 else if ext='.PAR' then newpath:='misc\par\'
 else if ext='.PER' then newpath:='misc\per\'
 else if ext='.PUP' then newpath:='misc\pup\'
 else if ext='.SND' then newpath:='misc\snd\'
 else if ext='.SPR' then newpath:='misc\spr\'
 else if ext='.WAV' then newpath:='sound\'
 else if ext='.BM' then newpath:='ui\bm\'
 else if ext='.SFT' then newpath:='ui\sft\'
 else if ext='.SMK' then newpath:='video\'
 else if ext='.SAN' then newpath:='video\'
 else if ext='.SND' then newpath:='snd\';

 if newPath='' then exit;
 if FileExists(pdir+newPath+name) then {warn if duplicate}
  Jed.PanMessage(1,'Can''t move file '+name+' - duplicate in '+newPath)
 else
 begin
  ForceDirectories(pdir,Newpath);
  RenameFile(pdir+name,pdir+newPath+name);
 end;
end;

begin
try
 jed:=CreateOLEObject('JED.App');
except
 {If CreateOLEObject failed, JED isn't installed or isn't running}
 on Exception do Stop('This is JED plugin. It should be run from JED','Error');
end;


{Check version}
if Jed.Version<0.81 then Stop('You shouldn''t use this plugin with JED version below 0.81','Error');


pdir:=jed.ProjectDir;

{If project directory is empty, the project is new and hasn't
 yet been saved}
if pdir='' then Stop('The project hasn''t been not saved','Error');

res:=FindFirst(pdir+'\*.*',faAnyFile,sr);

While res=0 do
begin
 if (Sr.Attr and (faVolumeID+faDirectory))=0 then
  MoveFile(sr.name);
 res:=FindNext(sr);
end;

FindClose(sr);

end.

